// ---- jobs.h ----

#ifndef JOBS_H
#define JOBS_H

#define MAX_JOBS 20

typedef struct st_job_cell {
  char *name;
  pid_t pid;
  enum { RUN, EXIT, STOP, SIG } status;
  int code;
  struct st_job_cell *next;
} *job_t;

void init_job_tab (void);

int can_create_new_job (void);

int exists_job (void);

job_t make_job (pipe_t);

int add_job (FILE *, job_t);

int wait_job (int, int *);

int put_in_fg_job (job_t, int *);

int put_fg_in_bg_job (void);

int kill_job (int, int);

int kill_jobs (int);

void update_print_jobs (FILE *);

void update_print_if_dead_jobs (FILE *);

#endif
