// ---- syntax.h ----

#ifndef SYNTAX_H
#define SYNTAX_H

#define MAX_LINE_SIZE 257
#define E_FGETS (-1)
#define E_TOO_LONG (-2)

typedef struct st_token_cell { //liste de token
  char *token;
  int used;
  struct st_token_cell *next;
} *token_list_t;

typedef enum {ARG, IN, OUT} elt_type; //type de l'argument : utile pour les redirections

typedef struct st_elt { //lment = mot+type
  elt_type type;
  char *word;
} elt_t;

typedef struct st_elt_cell {//liste d'lments
  elt_t elt;
  struct st_elt_cell *next;
} *elt_list_t;

typedef struct st_scomm {
  char *name;
  elt_list_t elt_list;
} scomm_t; // une commande simple

typedef struct st_pipe {
  scomm_t scomm;
  int fd[2]; // fd : les 2 fd du tube : entre + sortie
  pid_t pid;
  struct st_pipe *next;
} *pipe_t; // une liste de commandes simples 'pipes'

typedef struct st_comm {
  pipe_t pipe;
  int sync;
  struct st_comm *next;
} *comm_t; // une commande complete

typedef enum {SOFT, HARD} free_t; //type de libration : libration uniquement des cellules
//dans le cas de SOFT, de tout dans le cas de HARD


comm_t read_comm (FILE *);
/* lit une ligne sur le FILE* et renvoie la commande (cad liste de tubes) contenue
   dans cette ligne, si erreur de syntaxe, affiche un message et renvoie NULL 
 */

void free_comm (comm_t);
/* Libre l'espace memoire occup par la commande
 */

void print_comm (comm_t);
/* Affiche la description syntaxique de la commande
 */


#endif
